
%Generates Figure 1.



epselon=10;
beta=0.99;
frisch=1;

rgms=[1.0^0.25 1.005^0.25 1.01^0.25 1.015^0.25 1.02^0.25 1.025^0.25 1.03^0.25 1.035^0.25 1.04^0.25  ];

for i=1:length(rgms);
     rgm=rgms(i);
    
    thetas=[0.01 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 ];

    for n=1:length(thetas);
    theta=thetas(n);
    
k(n)=((1-theta*rgm^(epselon-1))*(1-theta*beta*rgm^epselon))/(theta*rgm^(epselon-1));




c1(n)=(1-beta*theta*rgm^(epselon-1));
c2(n)=(1-beta*theta*rgm^(epselon));

s1(n)=(1-theta)/(1-theta*(rgm^epselon));
s2(n)=((1-theta*(rgm^(epselon-1)))/(1-theta))^(epselon/(1-epselon));
s(n)=s1(n)*s2(n);

p_star=((1-theta*rgm^((epselon-1)))/(1-theta))^(1/(1-epselon));
s(n)=(1-theta)/(1-theta*rgm^((epselon)))*p_star^(-epselon);


t1(n)=(beta*epselon*(rgm-1)*(1-theta*rgm^(epselon-1)))/(k(n)*c1(n));
t2(n)=beta*theta*rgm^(epselon)/c1(n);


marginalmarkup(i,n)=(epselon/(epselon-1)*(1-beta*theta*(rgm)^(epselon-1))/(1-beta*theta*(rgm)^(epselon)));


pgap(i,n)=1/p_star;



results(i,n)=s(n);



    end

end
save ('results.mat')
save ('marginalmarkup')
save ('pgap')

sh1=		0.338			;
sh2	=		0.045			;
sh3	=		0.053			;
sh4	=		0.040			;
sh5	=		0.073			;
sh6	=		0.089			;
sh7	=		0.051			;
sh8	=		0.178			;
sh9	=		0.097		;
sh10	=		1-(sh1+sh2+sh3+sh4+sh5+sh6+sh7+sh8+sh9)	;



for i=1:length(rgms);
rstotal1=sh1*results(1,1)+sh2*results(1,2)+sh3*results(1,3)+sh4*results(1,4)+sh5*results(1,5)+sh6*results(1,6)+sh7*results(1,7)+sh8*results(1,8)+sh9*results(1,9)+sh10*results(1,10);
rmarginalmarkuptotal1=sh1*marginalmarkup(1,1)+sh2*marginalmarkup(1,2)+sh3*marginalmarkup(1,3)+sh4*marginalmarkup(1,4)+sh5*marginalmarkup(1,5)+sh6*marginalmarkup(1,6)+sh7*marginalmarkup(1,7)+sh8*marginalmarkup(1,8)+sh9*marginalmarkup(1,9)+sh10*marginalmarkup(1,10);
rpgaptotal1=sh1*pgap(1,1)+sh2*pgap(1,2)+sh3*pgap(1,3)+sh4*pgap(1,4)+sh5*pgap(1,5)+sh6*pgap(1,6)+sh7*pgap(1,7)+sh8*pgap(1,8)+sh9*pgap(1,9)+sh10*pgap(1,10);

rstotal(i)=sh1*results(i,1)+sh2*results(i,2)+sh3*results(i,3)+sh4*results(i,4)+sh5*results(i,5)+sh6*results(i,6)+sh7*results(i,7)+sh8*results(i,8)+sh9*results(i,9)+sh10*results(i,10);
rmarginalmarkuptotal(i)=sh1*marginalmarkup(i,1)+sh2*marginalmarkup(i,2)+sh3*marginalmarkup(i,3)+sh4*marginalmarkup(i,4)+sh5*marginalmarkup(i,5)+sh6*marginalmarkup(i,6)+sh7*marginalmarkup(i,7)+sh8*marginalmarkup(i,8)+sh9*marginalmarkup(i,9)+sh10*marginalmarkup(i,10);
rpgaptotal(i)=sh1*pgap(i,1)+sh2*pgap(i,2)+sh3*pgap(i,3)+sh4*pgap(i,4)+sh5*pgap(i,5)+sh6*pgap(i,6)+sh7*pgap(i,7)+sh8*pgap(i,8)+sh9*pgap(i,9)+sh10*pgap(i,10);


stotal(i)=(log(rstotal(i))-log(rstotal(1)))*100;
marginalmarkuptotal(i)=(log(rmarginalmarkuptotal(i))-log(rmarginalmarkuptotal(1)))*100;
pgaptotal(i)=(log(rpgaptotal(i))-log(rpgaptotal1))*100;

raveragemarkup(i)=rpgaptotal(i)*rmarginalmarkuptotal(i);

averagemarkup(i)=(log(raveragemarkup(i))-log(raveragemarkup(1)))*100;
%Yss(i)=-(frisch/(1+frisch))*stotal(i)-(1/(1+frisch))*averagemarkup(i);

rYss(i)= (1/(raveragemarkup(i)*rstotal(i)^frisch))^(1/(1+frisch));
Yss(i)=(log(rYss(i))-log(rYss(1)))*100;



end

for i=1:length(rgms);
     rgm=rgms(i);
    
    thetas=[0.6 0.6 0.6 0.6 0.6 0.6 0.6 0.6 0.6 0.6 ];
    %thetas=[0.75 0.75 0.75 0.75 0.75 0.75 0.75 0.75 0.75 0.75 ]
    for n=1:length(thetas);
    theta=thetas(n);
        
k(n)=((1-theta*rgm^(epselon-1))*(1-theta*beta*rgm^epselon))/(theta*rgm^(epselon-1));


%k(n)=((1-teta2*rgm^(epselon-1))*(1-teta2*beta*rgm^epselon))/(teta2*rgm^(epselon-1))

c1(n)=(1-beta*theta*rgm^(epselon-1));
c2(n)=(1-beta*theta*rgm^(epselon));

s1(n)=(1-theta)/(1-theta*rgm^epselon);
s2(n)=((1-theta*rgm^(epselon-1))/(1-theta))^(epselon/(1-epselon));

p_star=((1-theta*rgm^((epselon-1)))/(1-theta))^(1/(1-epselon));
Cs(n)=(1-theta)/(1-theta*rgm^((epselon)))*p_star^(-epselon);

t1(n)=(beta*epselon*(rgm-1)*(1-theta*rgm^(epselon-1)))/(k(n)*c1(n));
t2(n)=beta*theta*rgm^(epselon)/c1(n);

Cmarginalmarkup(i,n)=(epselon/(epselon-1)*(1-beta*theta*(rgm)^(epselon-1))/(1-beta*theta*(rgm)^(epselon)));

Cpgap(i,n)=1/p_star;





Cresults(i,n)=Cs(n);



    end

end
save ('Cresults.mat')
save ('Cmarginalmarkup')
save ('Cpgap')

sh1=		0.338			;
sh2	=		0.045			;
sh3	=		0.053			;
sh4	=		0.040			;
sh5	=		0.073			;
sh6	=		0.089			;
sh7	=		0.051			;
sh8	=		0.178			;
sh9	=		0.097			;
sh10	=		1-(sh1+sh2+sh3+sh4+sh5+sh6+sh7+sh8+sh9)	;



for i=1:length(rgms);
rCstotal1=sh1*Cresults(1,1)+sh2*Cresults(1,2)+sh3*Cresults(1,3)+sh4*Cresults(1,4)+sh5*Cresults(1,5)+sh6*Cresults(1,6)+sh7*Cresults(1,7)+sh8*Cresults(1,8)+sh9*Cresults(1,9)+sh10*Cresults(1,10);
rCmarginalmarkuptotal1=sh1*Cmarginalmarkup(1,1)+sh2*Cmarginalmarkup(1,2)+sh3*Cmarginalmarkup(1,3)+sh4*Cmarginalmarkup(1,4)+sh5*Cmarginalmarkup(1,5)+sh6*Cmarginalmarkup(1,6)+sh7*Cmarginalmarkup(1,7)+sh8*Cmarginalmarkup(1,8)+sh9*Cmarginalmarkup(1,9)+sh10*Cmarginalmarkup(1,10);
rCpgaptotal1=sh1*Cpgap(1,1)+sh2*Cpgap(1,2)+sh3*Cpgap(1,3)+sh4*Cpgap(1,4)+sh5*Cpgap(1,5)+sh6*Cpgap(1,6)+sh7*Cpgap(1,7)+sh8*Cpgap(1,8)+sh9*Cpgap(1,9)+sh10*Cpgap(1,10);

rCstotal(i)=sh1*Cresults(i,1)+sh2*Cresults(i,2)+sh3*Cresults(i,3)+sh4*Cresults(i,4)+sh5*Cresults(i,5)+sh6*Cresults(i,6)+sh7*Cresults(i,7)+sh8*Cresults(i,8)+sh9*Cresults(i,9)+sh10*Cresults(i,10);
rCmarginalmarkuptotal(i)=sh1*Cmarginalmarkup(i,1)+sh2*Cmarginalmarkup(i,2)+sh3*Cmarginalmarkup(i,3)+sh4*Cmarginalmarkup(i,4)+sh5*Cmarginalmarkup(i,5)+sh6*Cmarginalmarkup(i,6)+sh7*Cmarginalmarkup(i,7)+sh8*Cmarginalmarkup(i,8)+sh9*Cmarginalmarkup(i,9)+sh10*Cmarginalmarkup(i,10);
rCpgaptotal(i)=sh1*Cpgap(i,1)+sh2*Cpgap(i,2)+sh3*Cpgap(i,3)+sh4*Cpgap(i,4)+sh5*Cpgap(i,5)+sh6*Cpgap(i,6)+sh7*Cpgap(i,7)+sh8*Cpgap(i,8)+sh9*Cpgap(i,9)+sh10*Cpgap(i,10);

Cstotal(i)=(log(rCstotal(i))-log(rCstotal(1)))*100;
Cmarginalmarkuptotal(i)=(log(rCmarginalmarkuptotal(i))-log(rCmarginalmarkuptotal(1)))*100;
Cpgaptotal(i)=(log(rCpgaptotal(i))-log(rCpgaptotal1))*100;

Craveragemarkup(i)=rCpgaptotal(i)*rCmarginalmarkuptotal(i);
Caveragemarkup(i)=(log(Craveragemarkup(i))-log(Craveragemarkup(1)))*100;


rCYss(i)= (1/(Craveragemarkup(i)*rCstotal(i)^frisch))^(1/(1+frisch));
CYss(i)=(log(rCYss(i))-log(rCYss(1)))*100;


end

% w'=[0.5 0.5]
%  weighted_mean=w.*mean(results,2);
    
j=1:length(rgms);



figure;
subplot(1,3,1);
han=plot(j, CYss);
set(han,'LineWidth',2);
xticks([1 5 9])
xticklabels({'0','2','4'})
 a = get(gca,'XTickLabel');  
 set(gca,'XTickLabel',a,'fontsize',18)
%axis([1 9 -8 0 ])
axis tight,
hold on 
han=plot(j, Yss);
set(han,'LineWidth',1.5);
% set(gca,'xtickLabel',{'0','','1','','2','','3','','4'});
xlabel('Annualized trend inflation','FontSize',14)
ylabel('Long-run Output','FontSize',18)

legend({'Calvo','BK-MC'},'FontSize',18 )

subplot(1,3,2);
han=plot(j, Cstotal);
set(han,'LineWidth',2);
xticks([1 5 9])
xticklabels({'0','2','4'})
 a = get(gca,'XTickLabel');  
 set(gca,'XTickLabel',a,'fontsize',18)
%axis([1 9 -8 0 ])
axis tight,
hold on 

han=plot(j, stotal);
set(han,'LineWidth',2);
xlabel('Annualized trend inflation','FontSize',14)
ylabel('Price Dispersion','FontSize',18)


subplot(1,3,3);
han=plot(j, Caveragemarkup);
set(han,'LineWidth',1.5);
xticks([1 5 9])
xticklabels({'0','2','4'})
 a = get(gca,'XTickLabel');  
 set(gca,'XTickLabel',a,'fontsize',18)
%axis([1 9 -8 0 ])
axis tight,
hold on 

han=plot(j, averagemarkup);
set(han,'LineWidth',1.5);

xlabel('Annualized trend inflation','FontSize',14)
ylabel('Average Price Mark-up','FontSize',18)



% rgms=[1.0^0.25 1.02^0.25 1.04^0.25 1.06^0.25 1.1^0.25 ]
% 
% for i=1:length(rgms);
%     rgm=rgms(i);
%     
% k=((1-teta2*rgm^(epselon-1))*(1-teta2*beta*rgm^epselon))/(teta2*rgm^(epselon-1))
% d=beta*(rgm-1)*(1-teta2*rgm^(epselon-1));
% n=1-beta-d*epselon*(1/(1-beta*teta2*rgm^epselon));
% a=k+d;
% dev=n/(k+d)
% 
% results(:,i)=n;
% end
% 
% save ('results.mat')
% 
% j=1:length(rgms);
% 
% 
% han=plot(j, results);
% set(han,'LineWidth',1.5);
% 
% hold all
% 
% legend('2-sector MC', 'Calvo')
